Ideal
Model Tiny
CodeSeg
Org 80h

ComlineLen     db ?
FileName       db ?

Org 100h

Proc           Prog

               cmp sp,0FFFEh            ;Check for full segment
               jnz ErrorExit

               mov di,80h               ;Make filename ASCIIZ...
               cmp [byte di],1          ;No command line?
               jle ErrorExit
               inc di
               mov bl,[ComlineLen]      ;Check for leading spaces
               xor bh,bh
               mov cx,bx
               mov al,' '
               repe scasb
               dec di                   ;Save filename position
               mov dx,di                ;for open-file function
               mov cx,bx                ;Find the CR at the end
               mov al,0dh
               repne scasb
               dec di                   ;Put a 0 there (ASCIIZ)
               xor ax,ax
               stosb

               lea di,[Buffer]          ;Zero buffer
               mov cx,32000
               rep stosw
               
               mov ax,3D00h             ;Open file for read-only
               int 21h
               jc ErrorExit

               xchg bx,ax               ;Handle in BX
               mov ah,3Fh               ;Read file
               mov cx,64000             ;64000 bytes
               lea dx,[Buffer]          ;into Buffer
               int 21h
               jc ErrorExit

               mov ah,3Eh               ;Close file
               int 21h

               mov ax,13h               ;Switch to mode 13h
               int 10h
               
               lea di,[PaletteBuffer]   ;Set up gray palette
               mov cx,64
               xor ax,ax
PBLoop:        push cx
               mov cx,12
               rep stosb
               pop cx
               inc ax
               loop PBLoop
               
               mov ax,1012h             ;Gray the palette
               xor bx,bx
               inc ch
               lea dx,[PaletteBuffer]
               int 10h
               
               mov ax,0A000h            ;Point ES to video memory
               mov es,ax
               
               xor di,di
               lea si,[Buffer]          ;Store and show
               mov cx,32000
               rep movsw

               xor ax,ax                ;Wait for a key
               int 16h

               mov ax,3                 ;Switch back to text mode
               int 10h

               ret                      ;Quit

ErrorExit:     lea dx,[ErrorStr]        ;Display error/usage message
               mov ah,9
               int 21h
               ret

EndP           Prog

ErrorStr       db 'File not found',13,10
               db 'Usage: SHOW <file>$'

Org 200h

Buffer:

Org $+64000

PaletteBuffer:

End Prog
